#include "stdafx.h"
#include "InstallUtils.h"
#include "ScUtils.h"

void InstallDriver( const std::wstring& path, const std::wstring& driverName )
{
    sc_utils::ScHandleGuard manager(sc_utils::OpenManager());

    sc_utils::ScHandleGuard service(CreateService(
        manager.get(),
        driverName.c_str(),
        driverName.c_str(),
        SERVICE_ALL_ACCESS,
        SERVICE_KERNEL_DRIVER,
        SERVICE_DEMAND_START,
        SERVICE_ERROR_NORMAL,
        path.c_str(),
        NULL,
        NULL,
        NULL,
        NULL,
        NULL
        ));

    if (NULL == service.get())
    {
        throw std::runtime_error("Unable to create service");
    }
}

void UninstallDriver( const std::wstring& driverName )
{
    sc_utils::ScHandleGuard service(sc_utils::OpenDriverAsService(
        driverName.c_str(),
        DELETE
        ));

    if (NULL == service.get())
    {
        throw std::runtime_error("Unable to open service");
    }

    if (FALSE == DeleteService(service.get()))
    {
        throw std::runtime_error("Unable to delete service");
    }
}
