#ifndef RPC_ARCHIVE_H
#define RPC_ARCHIVE_H

#include <stdexcept>
#include <string>

//////////////////////////////////////////////////////////////////////////

namespace rpc
{
	class Archive
	{
	public:
		Archive(char* buf, size_t bufSize, size_t used = 0, size_t curRange = 0);
		
    public:
        void Actualize();
		size_t GetCurRange();

    public:
        // for clients
		char * TailAllocate(size_t size);
		void UnTail(size_t size);
		char * FetchRange(size_t size);
		char * FetchRange(size_t length, size_t size);
		size_t GetUsedSize() const;
		size_t GetSize() const;

    private:
        Archive(const Archive&);
        Archive & operator =(const Archive&);

    private:
        char * GetPtr();
        const char * GetPtr() const;

    private:
        size_t m_rangePtr;
        size_t m_usedSize;

        char* m_buf;
        const size_t m_bufSize;
	};
}//namespace rpc

#endif
