#ifndef RPC_INCORRECT_TYPE_ID
#define RPC_INCORRECT_TYPE_ID

#include <exception>
#include <stdio.h>

#pragma warning(push)
#pragma warning(disable:4996)

namespace rpc
{
    class IncorrectTypeId: public std::exception
    {
    public:
        IncorrectTypeId(int expected, int actual)
        {
            char buffer[256];
            _snprintf(buffer, 256, "Incorrect Type ID %d. %d was expected", actual, expected);
            msg = buffer;
        }

        ~IncorrectTypeId() throw() {};

        const char* what() const throw()
        {
            return msg.c_str();
        }

    private:
        std::string msg;
    };
}

#pragma warning(pop)

#endif
