#ifndef RPC_IOCTL_TRANSPORT_H
#define RPC_IOCTL_TRANSPORT_H

//////////////////////////////////////////////////////////////////////////

namespace rpc
{
    template <unsigned int RPC_IOCTL>
    class IoctlTransport
    {
    public:
        IoctlTransport(HANDLE device)
            : device_(device)
        {}

        void Send(char* buf, size_t inBufSize, size_t maxBufSize, size_t * BytesCount)
        {
            if (!DeviceIoControl(
                device_,
                RPC_IOCTL, 
                (void*)buf, 
                (DWORD)inBufSize, 
                (void*)buf, 
                (DWORD)maxBufSize, 
                (DWORD*)BytesCount,
                NULL)
                )
            {
                throw std::runtime_error("Device IO control failed");
            }
        }

    private:
        HANDLE device_;
    };
} //rpc

#endif
