#include "RpcServer.h"

void rpc::RpcServerImpl::RegisterObject(const std::string& objName, IRpcSkel* pObject)
{
    if (!objects_.insert(std::make_pair(objName, pObject)).second)
    {
        throw std::runtime_error(std::string(__FUNCTION__) + " - object " + objName + " already register.");
    }
}

void rpc::RpcServerImpl::UnregisterObject(const std::string& objName)
{
    objects_.erase(objName);
}

rpc::IRpcSkel* rpc::RpcServerImpl::FindObject(const std::string& objName)
{
    RpcObjectMap::iterator i = objects_.find(objName);
    if(i == objects_.end())
        throw std::runtime_error(std::string(__FUNCTION__) + " - object " + objName + " not registered");

    return i->second;
}