#include <boost/test/unit_test.hpp>

#include "RpcServer.h"
#include "RpcFakeTransport.h"
#include "RpcCall.h"

#include "TestObject.h"

typedef rpc::TL::Append<rpc::DefaultExceptions, CustomException>::Result MyExceptions;

struct RpcExceptionFix
{
    RpcExceptionFix() 
        : transport_(&server_)
        , testObject_(&server_)
    {
    }

    ~RpcExceptionFix() {}

    rpc::FakeTransport transport_;
    rpc::RpcServer<MyExceptions> server_; 
    TestObject testObject_;
};


BOOST_AUTO_TEST_SUITE(RpcExceptionTest)

BOOST_FIXTURE_TEST_CASE(TestCustomException, RpcExceptionFix)
{
    rpc::RpcCall<MyExceptions> rpcCall("test_object", "TestExceptionMethod");
    BOOST_REQUIRE_THROW(rpcCall.Call(&transport_), CustomException);
}

BOOST_AUTO_TEST_SUITE_END()
