#ifndef RPC_SERVER_TEST_H
#define RPC_SERVER_TEST_H

#include "RpcServer.h"
#include "RpcSkel.h"

#include <boost/test/unit_test.hpp>

struct TestSkel: rpc::IRpcSkel
{
    void Call
        ( const std::string& fncName, rpc::Archive& inBuf, rpc::Archive& outBuf)
    {
        if (fncName != "TestMethod")
            throw std::runtime_error("Wrong method name: " + fncName);

        testMethod(inBuf, outBuf);
    }

    void testMethod(rpc::Archive& inBuf, rpc::Archive& outBuf)
    {
        try
        {
            int val;
            rpc::Unpack(inBuf, &val);

            rpc::Pack(outBuf, val + 1);
        }
        catch (const std::exception& e)
        {
            BOOST_FAIL(e.what());
        }
        catch (...)
        {
            BOOST_FAIL("Unknown exception");
        }
    }
};

struct RpcServerFix
{
    RpcServerFix()
    {}

    //rpc::RpcServer<rpc::DefaultExceptions> rpcServer;
    rpc::RpcServer<rpc::DefaultExceptions> rpcServer;
};

#endif
